# Maker PI RP 2040 CircuitPython code
# Floor Robot Working + IR rec from new zapper
# Forwards,Backwards,Stop,Rspin,Lspin,Rturn,Lturn, Halt program
# Tony Goodhew 29 July 2021
import board
import sys
import neopixel
import simpleio
import time
import pwmio
import pulseio
from adafruit_motor import servo, motor
import digitalio
import adafruit_irremote

# Initialize DC motors
m1a = pwmio.PWMOut(board.GP8, frequency=50)
m1b = pwmio.PWMOut(board.GP9, frequency=50)
motor1 = motor.DCMotor(m1a, m1b)
m2a = pwmio.PWMOut(board.GP10, frequency=50)
m2b = pwmio.PWMOut(board.GP11, frequency=50)
motor2 = motor.DCMotor(m2a, m2b)

# Initialize Neopixel RGB LEDs
pixels = neopixel.NeoPixel(board.GP18, 2)
pixels.fill(0)

pulsein = pulseio.PulseIn(board.GP5, maxlen=120, idle_state=True)
decoder = adafruit_irremote.GenericDecode()
global running
def stop():
    motor1.throttle = 0
    motor2.throttle = 0
def forward(speed):
    motor1.throttle =-speed
    motor2.throttle =-speed
def backwards(speed):
    motor1.throttle = speed
    motor2.throttle = speed
def lspin(speed):
    motor1.throttle =speed
    motor2.throttle =-speed
def rspin(speed):
    motor1.throttle =-speed
    motor2.throttle = speed
def lturn(speed):
    motor1.throttle = 0
    motor2.throttle = -speed
def rturn(speed):
    motor1.throttle =-speed
    motor2.throttle = 0

def act(c): # Black Cross zapper
    if   c == 199: stop()
    elif c == 157: # Button#2 to halt Robot program
        running = False # Stop looping
        stop()
        magentaFlash()
        print("Halted")
        sys.exit() # System halt
    elif c == 231: forward(s)
    elif c == 181: backwards(s)
    elif c == 239: lspin(s)
    elif c == 165: rspin(s)
    elif c == 151: lturn(s)
    elif c == 79:  rturn(s)

def magentaFlash():
    for ii in range(3):
        pixels.fill(0xBB00BB)
        time.sleep(0.3)
        pixels.fill(0)
        time.sleep(0.3)
s = 0.4 # speed
running = True
while running:
    pulses = decoder.read_pulses(pulsein)
#    print("Heard", len(pulses), "Pulses:", pulses)
    try:
        code = decoder.decode_bits(pulses)
        print("Decoded:", code)
        if len(code) >=3:
            print(code[2])
            pixels.fill(0x00BB00)
            act(code[2])  # control robot routine
    except adafruit_irremote.IRNECRepeatException:  # unusual short code!
        print("NEC repeat!")
        pixels.fill(0x0000BB)
        stop()
    except adafruit_irremote.IRDecodeException as e:  # failed to decode
        print("Failed to decode: ", e.args)
        pixels.fill(0xBB0000)
        stop()
    print("----------------------------")
